Summary: LibCXXW
Name: libcxxw
Version: 0.7
Release: 1%{?extrarelease}
License: GPL
Group: System Environment/Libraries
URL: http://www.libcxx.org/w/
Source0: %{name}-%{version}.tar.bz2

%define _hardened_build 1

Requires: font(liberationsans)
Requires: font(liberationserif)
Requires: font(liberationmono)
Requires(post): /sbin/ldconfig
Requires(postun): /sbin/ldconfig

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: libcxxbase-devel
BuildRequires: freetype-devel
BuildRequires: fontconfig-devel
BuildRequires: libxcb-devel
BuildRequires: xcb-proto
BuildRequires: xcb-util-wm-devel
BuildRequires: xcb-util-keysyms-devel
BuildRequires: xcb-util-image-devel
BuildRequires: xcb-util-renderutil-devel
BuildRequires: libX11-devel
BuildRequires: libjpeg-turbo-devel
BuildRequires: giflib-devel
BuildRequires: libpng-devel
BuildRequires: desktop-file-utils

%description
LibCXX widget toolkit.

%package cups
Group: System Environment/Libraries
Summary: LibCXXW print dialog
Requires: %{name} = 0:%{version}-%{release}

%description cups
This package installs the LibCXXW printing dialog library.

%package devel
Group: Development/Libraries
Summary: LibCXXW development libraries
Requires: %{name} = 0:%{version}-%{release}
Requires: libcxxbase-devel
Requires: libX11-devel

%description devel
This package installs files needed to develop applications that use LibCXXW.

%package devel-internals
Group: Development/Libraries
Summary: LibCXXW development libraries
Requires: %{name}-devel = 0:%{version}-%{release}
Requires: libxcb-devel
BuildRequires: xcb-util-renderutil-devel

%description devel-internals
This package installs additional internal header files for building
custom LibCXXW display elements.

%prep
%setup -q
%configure

%build
%{__make} %{_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install DESTDIR=$RPM_BUILD_ROOT
RPM_BUILD_ROOT="$RPM_BUILD_ROOT" desktop-file-install cxxwtheme.desktop
rm -f $RPM_BUILD_ROOT/%{_libdir}/*.la

echo '%defattr(-,root,root,-)' >public-headers

(cd $RPM_BUILD_ROOT; find .%{_includedir}/x/w -name impl -prune -o -type f -print) | sed 's/^.//' >>public-headers

(cd $RPM_BUILD_ROOT; find .%{_includedir}/x/w -name impl -prune -o -type d -print) | sed 's@^.@%dir @' >>public-headers

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%{_libdir}/libcxxw.so.*
%{_datadir}/libcxxw
%{_datadir}/applications/*
%{_bindir}/*
%{_mandir}/*/*

%files cups
%defattr(-,root,root,-)
%{_libdir}/libcxxwcups.so.*

%files devel -f public-headers
%defattr(-,root,root,-)
%{_libdir}/*.so
%{_libdir}/*.a
%doc examples

%files devel-internals
%defattr(-,root,root,-)
%{_includedir}/x/w/impl
